;////////////////////////////////////////////////////////////////////////////;
;/ FNTPRINT.S                                                               /;
;////////////////////////////////////////////////////////////////////////////;
	.include	"\dev/gb/lib/global.s"
	.globl _font

;////////////////////////////////////////////////////////////////////////////;
	;.area _HEADER (ABS)
;////////////////////////////////////////////////////////////////////////////;
;	.org	0x40
	;jp	.Vbl_irq
	
;	.org	0x48
	;jp	.Lcd_irq

;////////////////////////////////////////////////////////////////////////////;
	.area _CODE
;////////////////////////////////////////////////////////////////////////////;

;////////////////////////////////////////////////////////////////////////////;
;/ _FntPrint                                                                /;
;////////////////////////////////////////////////////////////////////////////;
_FntPrint::
	push bc
	ld	b, #0
	


	;- c -
	
	lda	hl, 6(sp)		;0:bc, 2:ret, 4:x, 5:y, 6:c
	ld	c, (hl)			;get c (0..127)
	sla c				;c * sizeof(word)
	
	ld	hl, #.c_table
	add	hl, bc			;hl = &c_table[c]
	ld	a, (hl+)
	ld	h, (hl)
	ld	l, a			;hl = c_table[c]
	ld	de, #_font
	add	hl, de			;hl = &font[c]
	
	push hl				;push character address
	
	
	
	
	;- x -
	
	lda	hl, 6(sp)		;0:hl, 2:bc, 4:ret, 6:x, 7:y, 8:c
	ld	a, (hl+)		;get x (0..39)
	push af				;save x to get LSB later for left/right
		ld	d, (hl)			;get y (0..23)
		sla	d				;y * sizeof(word)
	
	srl	a				;x/2 (0..19)
	ldh (0x4F), a		;VBK: bit0 = even/odd tile
	and	a, #0xFE		;x/4 * sizeof(word)
	ld	c, a
	ld	hl, #.x_table
	add	hl, bc			;hl = &x_table[x/4]
	
		ld	c, d
	
	ld	a, (hl+)
	ld	d, (hl)
	ld	e, a			;de = x_table[x/4] = &screen[x][]
	
	;- y -
	
	ld	hl, #.y_table
	add	hl, bc			;hl = &y_table[y]
	ld	a, (hl+)
	ld	h, (hl)
	ld	l, a			;hl = y_table[y]
	add	hl, de			;hl = y_table[y] + x_table[x/4] = &screen[x][y]



	;-- left/right? --


	pop af				;get x
	pop de				;de = &font[c]
	and	a, #1			;x: even=left, odd=right part of tile
	jr	nz, .rchar




	;-- left --

.lchar:
	ld	c, #6
.lcopy:
	ld	a, (de)
	ld	b, a
	inc	de

1$:
	ldh	a, (0x41)
	bit	1, a
	jr	nz, 1$
	
	ld	a, (hl)			;get old data
	and	a, #0x0F		;clear part
	or	a, b
	
	ld	(hl+), a
	ld	(hl+), a
	dec	c
	jr	nz, .lcopy

	pop bc
ret


	;-- right --

.rchar:
	ld	c, #6
.rcopy:
	ld	a, (de)
	swap a
	ld	b, a
	inc de
	
1$:
	ldh	a, (0x41)
	bit	1, a
	jr	nz, 1$
	
	ld	a, (hl)			;get old data
	and	a, #0xF0		;clear part
	or	a, b
	
	ld	(hl+), a
	ld	(hl+), a
	dec	c
	jr	nz, .rcopy

	pop bc
ret




	;-- tables --

.x_table: ;0-10 (*2 banks for even/odd)
	.dw 0x8000,0x8150,0x82A0,0x83F0,0x8540,0x8690,0x87E0,0x8930
	.dw 0x8A80,0x8BD0,0x8D20

.y_table: ;0-27
	.dw 0x0000,0x000C,0x0018,0x0024,0x0030,0x003C,0x0048
	.dw 0x0054,0x0060,0x006C,0x0078,0x0084,0x0090,0x009C
	.dw 0x00A8,0x00B4,0x00C0,0x00CC,0x00D8,0x00E4,0x00F0
	.dw 0x00FC,0x0108,0x0114,0x0120,0x012C,0x0138,0x0144

.c_table: ;0-127
	.dw 0x0000,0x0006,0x000C,0x0012,0x0018,0x001E,0x0024,0x002A
	.dw 0x0030,0x0036,0x003C,0x0042,0x0048,0x004E,0x0054,0x005A
	.dw 0x0060,0x0066,0x006C,0x0072,0x0078,0x007E,0x0084,0x008A
	.dw 0x0090,0x0096,0x009C,0x00A2,0x00A8,0x00AE,0x00B4,0x00BA
	.dw 0x00C0,0x00C6,0x00CC,0x00D2,0x00D8,0x00DE,0x00E4,0x00EA
	.dw 0x00F0,0x00F6,0x00FC,0x0102,0x0108,0x010E,0x0114,0x011A
	.dw 0x0120,0x0126,0x012C,0x0132,0x0138,0x013E,0x0144,0x014A
	.dw 0x0150,0x0156,0x015C,0x0162,0x0168,0x016E,0x0174,0x017A
	.dw 0x0180,0x0186,0x018C,0x0192,0x0198,0x019E,0x01A4,0x01AA
	.dw 0x01B0,0x01B6,0x01BC,0x01C2,0x01C8,0x01CE,0x01D4,0x01DA
	.dw 0x01E0,0x01E6,0x01EC,0x01F2,0x01F8,0x01FE,0x0204,0x020A
	.dw 0x0210,0x0216,0x021C,0x0222,0x0228,0x022E,0x0234,0x023A
	.dw 0x0240,0x0246,0x024C,0x0252,0x0258,0x025E,0x0264,0x026A
	.dw 0x0270,0x0276,0x027C,0x0282,0x0288,0x028E,0x0294,0x029A
	.dw 0x02A0,0x02A6,0x02AC,0x02B2,0x02B8,0x02BE,0x02C4,0x02CA
	.dw 0x02D0,0x02D6,0x02DC,0x02E2,0x02E8,0x02EE,0x02F4,0x02FA
